package ejem08;

import java.awt.*;
import java.io.*;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

class DatosPersonales extends Panel implements KeyListener{
	
	
	Label Etis[]=new Label[7];
	TextField TFs[]=new TextField[7];
	String nomArch;
	long NoReg=0,totRegs=0;
	long lenReg=1;
	RandomAccessFile raf;
	
	DatosPersonales(String nomArch,int lenReg){
		setLayout(new GridLayout(7,2));
		Etis[0]=new Label("Nombre"); add(Etis[0]);
		TFs[0]=new TextField(30); add(TFs[0]);
		Etis[1]=new Label("Telefono"); add(Etis[1]);
		TFs[1]=new TextField(15); add(TFs[1]);
		Etis[2]=new Label("Direccion"); add(Etis[2]);
		TFs[2]=new TextField(45); add(TFs[2]);
		Etis[3]=new Label("e-mail"); add(Etis[3]);
		TFs[3]=new TextField(30); add(TFs[3]);
		Etis[4]=new Label("Dia"); add(Etis[4]);
		TFs[4]=new TextField(2); add(TFs[4]);
		Etis[5]=new Label("Mes"); add(Etis[5]);
		TFs[5]=new TextField(2); add(TFs[5]);
		Etis[6]=new Label("Ao"); add(Etis[6]);		
		TFs[6]=new TextField(4); add(TFs[6]);
		
		this.nomArch=nomArch;
		this.lenReg=lenReg;


		for(int i=0 ; i<7 ;i++){
			TFs[i].addKeyListener(this);
		}
		//ponDatoFalso();

		cargaArchivo();
	}


	public void ponDatoFalso(){
		setNombre("Alonso");
		setTelefono("658");
		setDireccion("Tepetapa");
		setE_mail("alonsorm77");
		setDia("14");
		setMes("03");
		setAnno("1977");
	}
	private void cargaArchivo(){
			try{
				raf=new RandomAccessFile(nomArch,"rw");
				totRegs=raf.length()/lenReg;
				System.out.println(totRegs);
				if(totRegs>0){
					ultiReg();
				}
			}
			catch(IOException e){
				System.out.println(e.getMessage());
			}
	}
	
	private void obtenDato(){
		byte lectura[]=new byte[100];
		long pos=(NoReg-1)*lenReg;
		int dia, mes ,anno;
		
		if(totRegs==0)
			return;
			
		//System.out.println(NoReg+","+totRegs);

		try{
			raf.seek(pos);

			raf.read(lectura,0,30);
			TFs[0].setText(new String(lectura));

			raf.read(lectura,0,15);
			TFs[1].setText(new String(lectura));

			raf.read(lectura,0,45);
			TFs[2].setText(new String(lectura));
			
			raf.read(lectura,0,30);
			TFs[3].setText(new String(lectura));
			
			dia= raf.readInt();
			mes= raf.readInt();
			anno= raf.readInt();
			
			TFs[4].setText(String.valueOf(dia));
			TFs[5].setText(String.valueOf(mes));
			TFs[6].setText(String.valueOf(anno));
			
		}
		catch(IOException e){
			System.out.println(e.getMessage());
		}

	}
	
	public void limpiaCampos(){
		for(int i=0 ;i<7;i++){
			TFs[i].setText("");
		}
	}
	public long getReg(){
		return NoReg;	
	}
	public void primReg(){
		NoReg=1;
		obtenDato();
	}

	public void ultiReg(){
		NoReg=totRegs;
		obtenDato();
	}
	
	public boolean avanzaReg(){
		if(NoReg<totRegs){
			NoReg++;
			obtenDato();
			return true;
		}
		return false;
	}
	
	public boolean regresaReg(){
		if(NoReg>1){
			NoReg--;
			obtenDato();
			return true;
		}
		return false;
	}
	
	public void agregaRegistro(){
		long anterior=NoReg;
		
		NoReg=totRegs+1;
		if(actualizaRegistro())
			totRegs++;
		else
			NoReg=anterior;
	}
	
	
	public boolean actualizaRegistro(){
	
		StringBuffer SB;
		String S;
		int dia,mes,anno;
		long pos=(NoReg-1)*lenReg;
		int enCual=0;
		
		try{
			dia=(new Integer(TFs[4].getText())).intValue();
			enCual=1;
			mes=(new Integer(TFs[5].getText())).intValue();
			enCual=2;
			anno=(new Integer(TFs[6].getText())).intValue();
		}
		catch(NumberFormatException e){
			if(enCual==0){
				TFs[4].setText("?");
			}
			else if(enCual==1){
				TFs[5].setText("?");
			}
			else if(enCual==2){
				TFs[6].setText("?");
			}
			return false;
		}
		
		if(dia>31){
			TFs[4].setText("?");
			return false;			
		}
		if(mes>12){
			TFs[5].setText("?");
			return false;			
		}
		
		System.out.println("Pos "+pos);
		try{
			raf.seek(pos);
			SB = new StringBuffer(TFs[0].getText());SB.setLength(30);S = new String(SB.toString());
			raf.write(S.getBytes(),0,30);

			SB = new StringBuffer(TFs[1].getText());SB.setLength(15);S = new String(SB.toString());
			raf.write(S.getBytes(),0,15);
			
			SB = new StringBuffer(TFs[2].getText());SB.setLength(45);S = new String(SB.toString());
			raf.write(S.getBytes(),0,45);
			
			SB = new StringBuffer(TFs[3].getText());SB.setLength(30);S = new String(SB.toString());
			raf.write(S.getBytes(),0,30);
			
			
			
			raf.writeInt(dia);
			raf.writeInt(mes);
			raf.writeInt(anno);
			
		}
		catch(IOException e){
			System.out.println(e.getMessage());
		}

		return true;
		
		// preparar el byte	b[];
		//byte b[] = new byte[lenReg];
	
		/*		
	 	public void write(byte b[],
	                   int off,
	                   int len) 
		*/		
	}
	
	public String getNombre(){
		return TFs[0].getText();	
	}
	public String getTelefono(){
		return TFs[1].getText();	
	}
	public String getDireccion(){
		return TFs[2].getText();	
	}
	public String getE_mail(){
		return TFs[3].getText();	
	}
	public String getDia(){
		return TFs[4].getText();	
	}
	public String getMes(){
		return TFs[5].getText();	
	}
	public String getAnno(){
		return TFs[6].getText();	
	}
	
	
	public void setNombre(String dato){
		TFs[0].setText(dato);	
	}
	public void setTelefono(String dato){
		TFs[1].setText(dato);	
	}
	public void setDireccion(String dato){
		TFs[2].setText(dato);	
	}
	public void setE_mail(String dato){
		TFs[3].setText(dato);	
	}
	public void setDia(String dato){
		TFs[4].setText(dato);	
	}
	public void setMes(String dato){
		TFs[5].setText(dato);	
	}
	public void setAnno(String dato){
		TFs[6].setText(dato);	
	}
	public void keyTyped(KeyEvent e){
		
	}
	public void keyPressed(KeyEvent e){
		
	}
	public void keyReleased(KeyEvent e){
		if(e.getSource()==TFs[0] && TFs[0].getText().length()>30){
			TFs[0].setText(TFs[0].getText().substring(0,30));
			TFs[0].setCaretPosition(TFs[0].getText().length());
		}
		if(e.getSource()==TFs[1] && TFs[1].getText().length()>15){
			TFs[1].setText(TFs[1].getText().substring(0,15));
			TFs[1].setCaretPosition(TFs[1].getText().length());
		}
		if(e.getSource()==TFs[2] && TFs[2].getText().length()>45){
			TFs[2].setText(TFs[2].getText().substring(0,45));
			TFs[2].setCaretPosition(TFs[2].getText().length());
		}
		if(e.getSource()==TFs[3] && TFs[3].getText().length()>30){
			TFs[3].setText(TFs[3].getText().substring(0,30));
			TFs[3].setCaretPosition(TFs[3].getText().length());
		}
		if(e.getSource()==TFs[4] && TFs[4].getText().length()>2){
			TFs[4].setText(TFs[4].getText().substring(0,2));
			TFs[4].setCaretPosition(TFs[4].getText().length());
		}
		if(e.getSource()==TFs[5] && TFs[5].getText().length()>2){
			TFs[5].setText(TFs[5].getText().substring(0,2));
			TFs[5].setCaretPosition(TFs[5].getText().length());
		}
		if(e.getSource()==TFs[6] && TFs[6].getText().length()>4){
			TFs[6].setText(TFs[6].getText().substring(0,4));
			TFs[6].setCaretPosition(TFs[6].getText().length());
		}
	}
}