package ejem08;

import java.awt.*;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


class TablaDatos extends Frame implements WindowListener,ActionListener{

	DatosPersonales DP;
	Button bPrimero,bUltimo,bAvanza,bDisminuye,bAgrega,bActualiza,bLimpia;
	Label Lb=new Label();
	
	
	TablaDatos(){
		super("Manejador de Tabla de Datos");
		DP=new DatosPersonales("Datos.dat",132);
		Panel P = new Panel();
		Lb.setBackground(Color.red);
		Lb.setForeground(Color.white);
		
		P.setLayout(new GridLayout(1,8));
		P.add(Lb);
		P.add(bPrimero=new Button("|<<"));
		P.add(bDisminuye=new Button("<-"));
		P.add(bAvanza=new Button("->"));
		P.add(bUltimo=new Button(">>|"));
		P.add(bAgrega=new Button("Agregar +"));
		P.add(bActualiza=new Button("Modifica"));
		P.add(bLimpia=new Button("Limpia"));
		
		add("Center",DP);
		add("South",P);
						
		addWindowListener(this);
		
		bPrimero.addActionListener(this);
		bDisminuye.addActionListener(this);
		bAvanza.addActionListener(this);
		bUltimo.addActionListener(this);
		bAgrega.addActionListener(this);
		bActualiza.addActionListener(this);
		bLimpia.addActionListener(this);
		
		
		setSize(new Dimension(500,300));
		PonRegistro();
	}	
	
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==bPrimero){
			DP.primReg();
		}
		else if(e.getSource()==bDisminuye){
			DP.regresaReg();
		}
		else if(e.getSource()==bAvanza){
			DP.avanzaReg();
		}
		else if(e.getSource()==bUltimo){
			DP.ultiReg();
		}
		else if(e.getSource()==bAgrega){
			DP.agregaRegistro();
		}
		else if(e.getSource()==bActualiza){
			boolean resp=DP.actualizaRegistro();
		}
		else if(e.getSource()==bLimpia){
			DP.limpiaCampos();
		}
		PonRegistro();
	}
	
	public void PonRegistro(){
		Lb.setText("#Reg="+String.valueOf(DP.getReg()));	
	}
	public void windowActivated(WindowEvent e) {}
	public void windowClosed(WindowEvent e) {}
	
	public void windowClosing(WindowEvent e) {
		setVisible(false);
		System.exit(0);
	}
	public void windowDeactivated(WindowEvent e) {}
	public void windowDeiconified(WindowEvent e){} 
	public void windowIconified(WindowEvent e){} 
	public void windowOpened(WindowEvent e) {}
	

	public static void main(String args[]){
		TablaDatos TD=new TablaDatos();
		TD.show();	
	}
}


